#!/bin/bash
#
# Copyright (C) 2018 Nikos Mavrogiannopoulos
#
# This file is part of ocserv.
#
# ocserv is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# ocserv is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# bash script because of echo -e

SERV="${SERV:-../src/ocserv}"
srcdir=${srcdir:-.}
NO_NEED_ROOT=1
PORT=4489
OTP_FILE=test-otp.$$.tmp

. `dirname $0`/common.sh

echo "Testing local backend with username-password-otp and certificate... "

$SERV --version 2>&1|grep oath >/dev/null 2>&1
if [ $? != 0 ];then
        exit 77
fi

#user 'test' has cert, password + OTP
#user 'testuser' has cert and OTP only

rm -f ${OTP_FILE}
cp data/test-otp.oath ${OTP_FILE}
update_config test-otp.config
launch_sr_server -d 1 -f -c ${CONFIG} & PID=$!
wait_server $PID

echo -n "Connecting with wrong username... "
( echo -e "test\n328482\n" | LD_PRELOAD=libsocket_wrapper.so $OPENCONNECT -q $ADDRESS:$PORT -u falsetest --servercert=d66b507ae074d03b02eafca40d35f87dd81049d3 --cookieonly >/dev/null 2>&1 ) &&
	fail $PID "Connected with wrong username!"
echo ok

echo -n "Connecting with wrong OTP... "
( echo -e "test\n999482\n" | LD_PRELOAD=libsocket_wrapper.so $OPENCONNECT -q $ADDRESS:$PORT -u test --servercert=d66b507ae074d03b02eafca40d35f87dd81049d3 --cookieonly >/dev/null 2>&1 ) &&
	fail $PID "Should not have connected with wrong OTP!"
echo ok

echo -n "Connecting with correct password and OTP... "
( echo -e "test\n328482\n" | LD_PRELOAD=libsocket_wrapper.so $OPENCONNECT -q $ADDRESS:$PORT -u test --servercert=d66b507ae074d03b02eafca40d35f87dd81049d3 --cookieonly >/dev/null 2>&1 ) ||
	fail $PID "Could not connect with OTP!"
echo ok

echo -n "Connecting with empty password and wrong OTP... "
( echo -e "999999\n" | LD_PRELOAD=libsocket_wrapper.so $OPENCONNECT -q $ADDRESS:$PORT -u testuser --servercert=d66b507ae074d03b02eafca40d35f87dd81049d3 --cookieonly >/dev/null 2>&1 ) &&
	fail $PID "Should have not connected with wrong OTP!"
echo ok

echo -n "Connecting with empty password and OTP... "
( echo -e "328482\n" | LD_PRELOAD=libsocket_wrapper.so $OPENCONNECT -q $ADDRESS:$PORT -u testuser --servercert=d66b507ae074d03b02eafca40d35f87dd81049d3 --cookieonly >/dev/null 2>&1 ) ||
	fail $PID "Could not connect with OTP-only!"
echo ok

rm -f ${OTP_FILE}
cleanup

exit 0
